import csv
import mymodule as mm

def ReadTextFile():
    #
    #       Prepare the input data file
    #
    s = input("Input data file = ")
    f = open(s, "r")
    #
    #       Set the contents of the input data file in the object data 
    #
    data = f.readlines()
    f.close()
    #
    #       Prepare the output file
    #
    s_out = input("Output data file (*.txt) = ")
    f_out = open(s_out, "w")
    f_out.write("Input data file (*.txt) = " + s + "\n\n")
        
    pos = 0
    pos = mm.check_slash(data, pos)
    pos = pos + 1
    #
    #       n_vars: the number of variables
    #
    n_vars = int(data[pos].strip())
    pos = mm.check_slash(data, pos) + 1
    #
    #       var_names: List of the variable names
    #
    var_names = data[pos].split();
    pos = mm.check_slash(data, pos) + 1
    temp_v = data[pos].split()
    #
    #       var_cond: the condition indices of the variables
    #                    0: No transformation
    #                    1: Standardization
    #                    2 <= : Quantification  
    #
    var_cond = []
    for a in temp_v:
        var_cond.append(int(a))

    n_data = 0;         #  n_data: the number of cases of the data,
                        #           which will be counted int the following steps
    #
    #       X: The input data matrix, which will be constructed
    #                                   in the following steps from the object data
    #
    X = [0]*n_vars              #  (n_var, n_data) array
    for a in range(0, n_vars):
        X[a] = []

    pos = mm.check_slash(data, pos) + 1
    temp_v = data[pos].split()
    #
    #       Add the first case to X
    #
    temp_p = 0
    for a in temp_v:
        X[temp_p].append(a)
        temp_p = temp_p + 1
    n_data = n_data + 1
    #
    #       Repeat addition of cases until the line with slash at the head is met
    #
    while True:
        temp_v = data[pos + n_data].split()
        if temp_v[0] == "/":
            break
        temp_p = 0
        for a in temp_v:
            X[temp_p].append(a)
            temp_p = temp_p + 1
        n_data = n_data + 1


    return f_out, s_out, n_data, n_vars, var_names, var_cond, X



def ReadCSVFile():
    #
    #       Prepare the input data file
    #
    f_in_nm = input("Input data file (*.csv) = ")
    with open(f_in_nm, 'r') as f:
        csv_data = [d for d in csv.reader(f)]
    
    #
    #       Prepare the output file
    #
    s_out = input("Output data file (*.txt) = ")
    f_out = open(s_out, "w")
    f_out.write("Input data file = " + f_in_nm + "\n\n")

    #
    #       n_vars: the number of variables
    #

    n_vars = len(csv_data[0])
    
    #
    #       var_names: List of the variable names
    #

    var_names = csv_data[0]

    #
    #       var_cond: the condition indices of the variables
    #                    0: No transformation
    #                    1: Standardization
    #                    2 <= : Quantification  
    #

    var_cond = []
    for v in csv_data[1]:
        var_cond.append(int(v))

    n_data = len(csv_data) - 2

    X = []
    for j in range(n_vars):
        X.append([])
    for i in range(2, n_data + 2):
        for j in range(n_vars):
            X[j].append(csv_data[i][j])

    return f_out, s_out, n_data, n_vars, var_names, var_cond, X

